<template>
  <BasicModal
    v-bind="$attrs"
    @cancel="resetFields"
    @register="register"
    :title="title"
    @ok="handleOk"
  >
    <div class="pt-3px pr-3px">
      <BasicForm @register="registerForm" :model="modelRef" />
    </div>
  </BasicModal>
</template>
<script lang="ts">
  import { defineComponent, ref, computed, h } from 'vue';
  import {
    checkUserApi,
    saveApi,
    updateApi,
    getRoleListByParam,
    uploadApi,
  } from '/@/api/staff/list'; //roleLIstApi
  import { getAllList } from '/@/api/rightsEnterprises/list';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, FormSchema, useForm } from '/@/components/Form/index';
  import { ListAllCompanyApi } from '/@/api/corporation/list';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useUserStore } from '/@/store/modules/user';
  import { CropperAvatar } from '/@/components/Cropper';
  import { Result } from '/#/axios';
  const { t } = useI18n();
  export default defineComponent({
    components: { BasicModal, BasicForm },
    props: {
      userData: { type: Object },
    },
    emits: ['register', 'ok'],
    setup(_, context) {
      const modelRef = ref({});
      const userStore = useUserStore();
      const { getCheckRole } = userStore;
      const userinfo = computed(() => userStore.getUserInfo);
      const { companyId } = userinfo.value;
      console.log('companyId', companyId);
      const permListOptions = computed(() => {
        return [
          {
            label: '带看',
            value: '1',
          },
          {
            label: '拍摄',
            value: '2',
          },
        ];
      });
      const schemas: FormSchema[] = [
        {
          field: 'phone',
          component: 'Input',
          label: '手机号',
          colProps: {
            span: 18,
          },
          // helpMessage: '手机号需在指房宝APP注册后才可新增',
          required: false,
          rules: [
            {
              required: true,
              // @ts-ignore
              validator: async (rule, value) => {
                var reg_tel =
                  /^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\d{8}$/;
                // var reg = /\S+@\S+\.\S+/;
                if (!value) {
                  return Promise.reject(t('common.phone'));
                }
                if (!reg_tel.test(value)) {
                  /* eslint-disable-next-line */
                  return Promise.reject(t('common.phoneError'));
                }
                try {
                  if (title.value == '编辑') {
                    return Promise.resolve();
                  }
                  let res = await checkUserApi({ phone: value });
                  console.log('res', res, 'title', title.value);
                  if (res == true) {
                    return Promise.resolve();
                  } else {
                    return Promise.reject('手机号未在指房宝APP中进行注册');
                  }
                } catch (err) {
                  return Promise.reject(err);
                }
              },
              trigger: 'change',
            },
          ],
        },
        {
          field: 'nickName',
          component: 'Input',
          label: '员工名称',
          colProps: {
            span: 22,
          },
          componentProps: {
            maxLength: 15,
          },
          rules: [
            {
              required: true,
              // @ts-ignore
              validator: async (rule, value) => {
                var reg_tel = /^[a-zA-Z\u4e00-\u9fa5]+$/;
                // var reg = /\S+@\S+\.\S+/;
                if (!value) {
                  return Promise.reject('请输入员工名称');
                }
                if (!reg_tel.test(value)) {
                  /* eslint-disable-next-line */
                  return Promise.reject('请输入正确的员工名称');
                }
                return Promise.resolve();
              },
              trigger: 'change',
            },
          ],
        },
        {
          field: 'companyId',
          label: '公司',
          component: 'ApiSelect',
          itemProps: {
            validateTrigger: 'blur',
          },
          colProps: {
            span: 22,
          },
          required: true,
          ifShow: getCheckRole('plat_admin'),
          componentProps: {
            api: ListAllCompanyApi,
            showSearch: true,
            resultField: 'list',
            labelField: 'name',
            valueField: 'id',
            immediate: true,
            params: {
              page: 1,
              limit: 1000,
            },
            required: true,
            onChange: companyIdChange,
          },
        },
        {
          field: 'roleId',
          component: 'ApiSelect',
          label: '角色',
          required: true,
          itemProps: {
            validateTrigger: 'blur',
          },
          colProps: {
            span: 22,
          },
          defaultValue: 8,
          componentProps: {
            options: [
              {
                label: '公司员工',
                value: 8,
                key: 8,
              },
            ],
          },
        },
        {
          field: 'permList',
          component: 'ApiSelect',
          label: '权益',
          colProps: {
            span: 22,
          },
          componentProps: {
            api: async function (params) {
              const res = await getAllList(params);
              console.log('params', params, res);
              // const treeData = makeTree(res);
              return res.map((i) => {
                return {
                  ...i,
                  permName: i.permName + '  ' + i.createTime,
                };
              });
            },
            labelField: 'permName',
            valueField: 'id',
            immediate: true,
            mode: 'multiple',
            params: {
              page: 1,
              limit: 100,
              // companyId:
            },
            required: true,
          },
        },
        {
          field: 'head',
          label: '员工头像',
          component: 'Upload',
          required: false,
          // defaultValue: 1,
          itemProps: {
            validateTrigger: 'blur',
          },
          helpMessage: '推荐大小：400 * 400 像素',
          render: ({ model, field }) => {
            return h(CropperAvatar, {
              value: model[field],
              maxlength: 200,
              uploadApi: uploadApi,
              showBtn: false,
              maxNumber: 1,
              accept: ['jpg', 'jpeg', 'gif', 'png'],
              onChange: (_, source: Result) => {
                console.log('onChange', source.message);
                model[field] = source.message;
              },
              showImageUpload: true,
            });
          },
          // componentProps: {
          //   api: uploadApi,
          //   maxNumber: 1,
          //   accept: ['jpg', 'jpeg', 'gif', 'png'],
          //   afterFetch: function (data) {
          //     console.log('data', data);
          //     Reflect.set(data, 'url', data.message);
          //     return data;
          //   },
          // },
        },
        // {
        //   field: 'avatar',
        //   component: 'Upload',
        //   label: '员工头像',
        //   required: true,
        //   rules: [{ required: true, message: '请选择上传文件' }],
        //   helpMessage: '推荐大小：400 * 400 像素',
        //   itemProps: {
        //     validateTrigger: 'onBlur',
        //   },
        //   // componentProps: {
        //   //   api: uploadLogoApi,
        //   //   maxNumber: 1,
        //   //   maxSize: 10,
        //   //   accept: ['jpg', 'jpeg', 'gif', 'png'],
        //   //   afterFetch: function (data) {
        //   //     console.log('data', data);
        //   //     Reflect.set(data, 'url', data.message);
        //   //     return data;
        //   //   },
        //   // },

        //   colProps: {
        //     span: 22,
        //   },
        // },
        {
          field: 'id',
          component: 'Input',
          label: 'id',
          show: false,
        },
      ];
      const title = ref('新 增');
      const { createMessage } = useMessage();
      const [registerForm, { setFieldsValue, validate, updateSchema, resetFields }] = useForm({
        labelWidth: 120,
        schemas,
        showActionButtonGroup: false,
        actionColOptions: {
          span: 24,
        },
      });

      const [register, { closeModal }] = useModalInner((data) => {
        data && onDataReceive(data);
      });
      function onDataReceive(data) {
        // 方式1;
        console.log('useModalInner', data);
        resetFields();
        setFieldsValue({
          ...data,
          roleId: data.roleId != 2 ? data.roleId : '',
        });
        let setSchema: FormSchema[] = [
          {
            field: 'roleId',
            component: 'ApiSelect',
            label: '角色',
            componentProps: {
              disabled: data.roleId == 2 ? false : data.id ? true : false,
              api: getRoleListByParam,
              labelField: 'roleName',
              valueField: 'roleId',
              params: {
                type: data.roleId ? 1 : 0,
                roleId: data.roleId,
              },
            },
          },
          {
            field: 'phone',
            label: '手机号',
            component: 'Input',
            componentProps: {
              disabled: getCheckRole('plat_admin') ? false : data.id ? true : false,
            },
          },
          {
            field: 'companyId',
            label: '公司',
            component: 'ApiSelect',
            componentProps: {
              disabled: data.id ? (data.roleId != 2 ? true : false) : false,
            },
          },
          {
            field: 'permList',
            component: 'ApiSelect',
            label: '权益',
            componentProps: {
              disabled: data.roleId == 2 ? false : data.id ? true : false,
              params: {
                companyId: data.companyId || companyId,
              },
            },
          },
        ];
        title.value = data.id ? '编辑' : '新增';
        updateSchema(setSchema);
      }
      function companyIdChange(companyId) {
        // resetFields(['permList'])
        updateSchema([
          {
            field: 'permList',
            componentProps: {
              params: {
                companyId: companyId,
              },
            },
          },
        ]);
        setFieldsValue({
          permList: [],
        });
      }
      async function handleOk() {
        let data = await validate();
        const requestApi = data.id ? updateApi : saveApi;
        let res = await requestApi({
          ...data,
          userName: data.phone,
          head: data.head,
          phone: data.phone,
          nickName: data.nickName,
          roleId: data.roleId,
          id: data.id,
        });
        console.log('res', res);
        context && context.emit('ok', res);
        createMessage.success(t('common.optSuccess'));
        closeModal();
        resetFields();
      }

      return {
        register,
        title,
        schemas,
        registerForm,
        modelRef,
        handleOk,
        resetFields,
        permListOptions,
      };
    },
  });
</script>
